Imported Debian version 2.5.0~trusty1.1
[deb_ffmpeg.git] / ffmpeg / tests / fate-run.sh
CommitLineData
2ba45a60
DM
1#! /bin/sh
2
3export LC_ALL=C
4
5base=$(dirname $0)
6. "${base}/md5.sh"
7
8base64=tests/base64
9
10test="${1#fate-}"
11target_samples=$2
12target_exec=$3
13target_path=$4
14command=$5
15cmp=${6:-diff}
16ref=${7:-"${base}/ref/fate/${test}"}
17fuzz=${8:-1}
18threads=${9:-1}
19thread_type=${10:-frame+slice}
20cpuflags=${11:-all}
21cmp_shift=${12:-0}
22cmp_target=${13:-0}
23size_tolerance=${14:-0}
24cmp_unit=${15:-2}
25gen=${16:-no}
26
27outdir="tests/data/fate"
28outfile="${outdir}/${test}"
29errfile="${outdir}/${test}.err"
30cmpfile="${outdir}/${test}.diff"
31repfile="${outdir}/${test}.rep"
32
33target_path(){
34 test ${1} = ${1#/} && p=${target_path}/
35 echo ${p}${1}
36}
37
38# $1=value1, $2=value2, $3=threshold
39# prints 0 if absolute difference between value1 and value2 is <= threshold
40compare(){
41 echo "scale=2; v = $1 - $2; if (v < 0) v = -v; if (v > $3) r = 1; r" | bc
42}
43
44do_tiny_psnr(){
45 psnr=$(tests/tiny_psnr "$1" "$2" $cmp_unit $cmp_shift 0)
46 val=$(expr "$psnr" : ".*$3: *\([0-9.]*\)")
47 size1=$(expr "$psnr" : '.*bytes: *\([0-9]*\)')
48 size2=$(expr "$psnr" : '.*bytes:[ 0-9]*/ *\([0-9]*\)')
49 val_cmp=$(compare $val $cmp_target $fuzz)
50 size_cmp=$(compare $size1 $size2 $size_tolerance)
51 if [ "$val_cmp" != 0 ] || [ "$size_cmp" != 0 ]; then
52 echo "$psnr"
53 return 1
54 fi
55}
56
57oneoff(){
58 do_tiny_psnr "$1" "$2" MAXDIFF
59}
60
61stddev(){
62 do_tiny_psnr "$1" "$2" stddev
63}
64
65oneline(){
66 printf '%s\n' "$1" | diff -u -b - "$2"
67}
68
69run(){
70 test "${V:-0}" -gt 0 && echo "$target_exec" $target_path/"$@" >&3
71 $target_exec $target_path/"$@"
72}
73
74runecho(){
75 test "${V:-0}" -gt 0 && echo "$target_exec" $target_path/"$@" >&3
76 $target_exec $target_path/"$@" >&3
77}
78
79probefmt(){
80 run ffprobe -show_entries format=format_name -print_format default=nw=1:nk=1 -v 0 "$@"
81}
82
83probeframes(){
84 run ffprobe -show_frames -v 0 "$@"
85}
86
87ffmpeg(){
88 dec_opts="-threads $threads -thread_type $thread_type"
89 ffmpeg_args="-nostats -cpuflags $cpuflags"
90 for arg in $@; do
91 [ x${arg} = x-i ] && ffmpeg_args="${ffmpeg_args} ${dec_opts}"
92 ffmpeg_args="${ffmpeg_args} ${arg}"
93 done
94 run ffmpeg ${ffmpeg_args}
95}
96
97framecrc(){
98 ffmpeg "$@" -flags +bitexact -f framecrc -
99}
100
101framemd5(){
102 ffmpeg "$@" -flags +bitexact -f framemd5 -
103}
104
105crc(){
106 ffmpeg "$@" -f crc -
107}
108
109md5(){
110 ffmpeg "$@" md5:
111}
112
113pcm(){
114 ffmpeg "$@" -vn -f s16le -
115}
116
f6fa7814
DM
117fmtstdout(){
118 fmt=$1
119 shift 1
120 ffmpeg -flags +bitexact "$@" -f $fmt -
121}
122
2ba45a60
DM
123enc_dec_pcm(){
124 out_fmt=$1
125 dec_fmt=$2
126 pcm_fmt=$3
127 src_file=$(target_path $4)
128 shift 4
129 encfile="${outdir}/${test}.${out_fmt}"
130 cleanfiles=$encfile
131 encfile=$(target_path ${encfile})
132 ffmpeg -i $src_file "$@" -f $out_fmt -y ${encfile} || return
133 ffmpeg -flags +bitexact -i ${encfile} -c:a pcm_${pcm_fmt} -f ${dec_fmt} -
134}
135
136FLAGS="-flags +bitexact -sws_flags +accurate_rnd+bitexact -fflags +bitexact"
137DEC_OPTS="-threads $threads -idct simple $FLAGS"
138ENC_OPTS="-threads 1 -idct simple -dct fastint"
139
140enc_dec(){
141 src_fmt=$1
142 srcfile=$2
143 enc_fmt=$3
144 enc_opt=$4
145 dec_fmt=$5
146 dec_opt=$6
147 encfile="${outdir}/${test}.${enc_fmt}"
148 decfile="${outdir}/${test}.out.${dec_fmt}"
149 cleanfiles="$cleanfiles $decfile"
150 test "$7" = -keep || cleanfiles="$cleanfiles $encfile"
151 tsrcfile=$(target_path $srcfile)
152 tencfile=$(target_path $encfile)
153 tdecfile=$(target_path $decfile)
154 ffmpeg -f $src_fmt $DEC_OPTS -i $tsrcfile $ENC_OPTS $enc_opt $FLAGS \
155 -f $enc_fmt -y $tencfile || return
156 do_md5sum $encfile
157 echo $(wc -c $encfile)
158 ffmpeg $8 $DEC_OPTS -i $tencfile $ENC_OPTS $dec_opt $FLAGS \
159 -f $dec_fmt -y $tdecfile || return
160 do_md5sum $decfile
161 tests/tiny_psnr $srcfile $decfile $cmp_unit $cmp_shift
162}
163
164lavffatetest(){
165 t="${test#lavf-fate-}"
166 ref=${base}/ref/lavf-fate/$t
167 ${base}/lavf-regression.sh $t lavf-fate tests/vsynth1 "$target_exec" "$target_path" "$threads" "$thread_type" "$cpuflags" "$target_samples"
168}
169
170lavftest(){
171 t="${test#lavf-}"
172 ref=${base}/ref/lavf/$t
173 ${base}/lavf-regression.sh $t lavf tests/vsynth1 "$target_exec" "$target_path" "$threads" "$thread_type" "$cpuflags" "$target_samples"
174}
175
176video_filter(){
177 filters=$1
178 shift
179 label=${test#filter-}
180 raw_src="${target_path}/tests/vsynth1/%02d.pgm"
181 printf '%-20s' $label
182 ffmpeg $DEC_OPTS -f image2 -vcodec pgmyuv -i $raw_src \
183 $FLAGS $ENC_OPTS -vf "$filters" -vcodec rawvideo $* -f nut md5:
184}
185
186pixfmts(){
187 filter=${test#filter-pixfmts-}
188 filter=${filter%_*}
189 filter_args=$1
190 prefilter_chain=$2
191
192 showfiltfmts="$target_exec $target_path/libavfilter/filtfmts-test"
193 scale_exclude_fmts=${outfile}_scale_exclude_fmts
194 scale_in_fmts=${outfile}_scale_in_fmts
195 scale_out_fmts=${outfile}_scale_out_fmts
196 in_fmts=${outfile}_in_fmts
197
198 # exclude pixel formats which are not supported as input
199 $showfiltfmts scale | awk -F '[ \r]' '/^INPUT/{ fmt=substr($3, 5); print fmt }' | sort >$scale_in_fmts
200 $showfiltfmts scale | awk -F '[ \r]' '/^OUTPUT/{ fmt=substr($3, 5); print fmt }' | sort >$scale_out_fmts
201 comm -12 $scale_in_fmts $scale_out_fmts >$scale_exclude_fmts
202
203 $showfiltfmts $filter | awk -F '[ \r]' '/^INPUT/{ fmt=substr($3, 5); print fmt }' | sort >$in_fmts
204 pix_fmts=$(comm -12 $scale_exclude_fmts $in_fmts)
205
f6fa7814 206 outertest=$test
2ba45a60
DM
207 for pix_fmt in $pix_fmts; do
208 test=$pix_fmt
209 video_filter "${prefilter_chain}format=$pix_fmt,$filter=$filter_args" -pix_fmt $pix_fmt
210 done
211
212 rm $in_fmts $scale_in_fmts $scale_out_fmts $scale_exclude_fmts
f6fa7814 213 test=$outertest
2ba45a60
DM
214}
215
216mkdir -p "$outdir"
217
218# Disable globbing: command arguments may contain globbing characters and
219# must be kept verbatim
220set -f
221
222exec 3>&2
223eval $command >"$outfile" 2>$errfile
224err=$?
225
226if [ $err -gt 128 ]; then
227 sig=$(kill -l $err 2>/dev/null)
228 test "${sig}" = "${sig%[!A-Za-z]*}" || unset sig
229fi
230
231if test -e "$ref" || test $cmp = "oneline" ; then
232 case $cmp in
233 diff) diff -u -b "$ref" "$outfile" >$cmpfile ;;
f6fa7814 234 rawdiff)diff -u "$ref" "$outfile" >$cmpfile ;;
2ba45a60
DM
235 oneoff) oneoff "$ref" "$outfile" >$cmpfile ;;
236 stddev) stddev "$ref" "$outfile" >$cmpfile ;;
237 oneline)oneline "$ref" "$outfile" >$cmpfile ;;
238 null) cat "$outfile" >$cmpfile ;;
239 esac
240 cmperr=$?
241 test $err = 0 && err=$cmperr
242 test $err = 0 || cat $cmpfile
243else
244 echo "reference file '$ref' not found"
245 err=1
246fi
247
248echo "${test}:${sig:-$err}:$($base64 <$cmpfile):$($base64 <$errfile)" >$repfile
249
250if test $err != 0 && test $gen != "no" ; then
251 echo "GEN $ref"
252 cp -f "$outfile" "$ref"
253 err=$?
254fi
255
256if test $err = 0; then
257 rm -f $outfile $errfile $cmpfile $cleanfiles
258elif test $gen = "no"; then
259 echo "Test $test failed. Look at $errfile for details."
260 test "${V:-0}" -gt 0 && cat $errfile
261else
262 echo "Updating reference failed, possibly no output file was generated."
263fi
264exit $err